/* 
    LSDictionary by LouiSe@louise.hu
    
    http://www.louise.hu
 */

var grepCommand = "/usr/bin/grep";
var sortCommand = "sort -d -u -f";
var grepMaxResults = 50;
var intensity = 1;

var lang_1="en";
var lang_2="hu";
// var langPair_1 = lang_1+"|"+lang_2;
// var langPair_2 = lang_2+"|"+lang_1;
var langPair_1 = "|"+lang_2;
var langPair_2 = "|"+lang_1;
var dictionaryFolder = "dictionaries";
var dictionaryFiles = dictionaryFolder+"/"+lang_1+"-"+lang_2+"*.dic"; // "en-hu*.dic";
var myDictionaryFile = dictionaryFolder+"/"+lang_1+"-"+lang_2+"_mywords.dic"; // "en-hu_mywords.dic";
var fieldSeparator = " :: ";

var addMyWordCommand = "/bin/echo >>"+myDictionaryFile;

var googleUrl = "http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&is=UTF8";
var googleUrlDetectLanguage = "http://ajax.googleapis.com/ajax/services/language/detect?v=1.0&is=UTF8";
var googleQueryText = "q=";
// var googleUrl = "http://google.com/translate_t?is=UTF8";
// var googleQueryText = "text=";
var googleLangpair = "langpair=";   // en|hu
var googleFound = false;
var googleAddButton = null;
var currentlyBeingTranslated = null;

// var speechVoice = "-v \"Alex\"";
var speechVoice = "";
var currentlyBeingSpoken = null;

var queryURL = null;

var translateCommand = null;
var commandString = null;
var word = null;
var originalWord = null;

/**
 * Speak clicked text
 */
function speakWord(event) {
    var clickedText = event.toElement.innerText;

    var firstText = clickedText.split("\n")[0];
    var speakText = "";
    
    var removeChars = false;
    for(var i=0;i<firstText.length;i++) {
        if(firstText.substr(i, 1) == "[") removeChars = true;
        if(removeChars == false) {
            if(firstText.substr(i, 1)=="\"" ) {
                speakText += " ";
            } else {
                speakText += firstText.substr(i, 1);
            }
        }
    }

    if( currentlyBeingSpoken != null) {
        currentlyBeingSpoken.cancel();
    }

    currentlyBeingSpoken = widget.system("/usr/bin/say \""+speakText+"\" "+speechVoice, doneSpeaking);

}

function doneSpeaking()
{
	currentlyBeingSpoken = null;
}

/**
 * Add new word-pair to local store
 */
function addMyWord(event) {
    var firstText = document.getElementById('firstTextToAdd').value;
    var secondText = document.getElementById('secondTextToAdd').value;
    
    // document.getElementById('content').innerHTML = "<center><br/><br/><br/><br/><strong>OK</strong></center>"+firstText+"-"+secondText;
    
    if(firstText.length>2 && secondText.length>2) {
        var c = addMyWordCommand+" \""+firstText+fieldSeparator+secondText+"\"";
        widget.system(c, doneAddWord);
    }
}

function doneAddWord()
{
    document.getElementById('firstTextToAdd').value = "";
    document.getElementById('secondTextToAdd').value = "";

    // document.getElementById('content').innerHTML = "<center><br/><br/><br/><br/><strong>OK</strong></center>";
    
    showFront();
}


function createGrepCommand(word, countOnly)
{
	var paramString  = " -h -i";
	
	if(countOnly == true)
	{	
		paramString += " --count";
	}else
	{
		paramString += " -m "+grepMaxResults;
	}
		
	if (intensity == 0)
	{
		paramString += " -w \"" + word + "\"";
	}
	else if (intensity == 1)
	{
		paramString += " -E \"(^|:: )" + word + "\"";
	}
	else if (intensity == 2)
	{
		paramString += " \"" + word + "\"";
	}

	var result = grepCommand + paramString + " " + dictionaryFiles + " | " + sortCommand;
	return result;
}

function HTMLencode(word)
{
    if(word) {
        word =  replaceAll(word, "ä", "&auml;");
        word =  replaceAll(word, "Ä", "&Auml;");
        word =  replaceAll(word, "ü", "&uuml;");
        word =  replaceAll(word, "Ü", "&Uuml;");
        word =  replaceAll(word, "ö", "&ouml;");
        word =  replaceAll(word, "Ö", "&Ouml;");
        word =  replaceAll(word, "ß", "&szlig;");

        word =  replaceAll(word, "ő", "&otilde;");
        word =  replaceAll(word, "Ő", "&Otilde;");
        word =  replaceAll(word, "ű", "&ucirc;");
        word =  replaceAll(word, "Ű", "&Ucirc;");
        word =  replaceAll(word, "ó", "&oacute;");
        word =  replaceAll(word, "Ó", "&Oacute;");
        word =  replaceAll(word, "ú", "&uacute;");
        word =  replaceAll(word, "Ú", "&Uacute;");
        word =  replaceAll(word, "í", "&iacute;");
        word =  replaceAll(word, "Í", "&Iacute;");
        word =  replaceAll(word, "é", "&eacute;");
        word =  replaceAll(word, "É", "&Eacute;");
        word =  replaceAll(word, "á", "&aacute;");
        word =  replaceAll(word, "Á", "&Aacute;");
    }
	return word;
}

function HTMLdecode(word)
{
	word =  replaceAll(word, "&auml;", "ä");
	word =  replaceAll(word, "&Auml;", "Ä");
	word =  replaceAll(word, "&uuml;", "ü");
	word =  replaceAll(word, "&Uuml;", "Ü");
	word =  replaceAll(word, "&ouml;", "ö");
	word =  replaceAll(word, "&Ouml;", "Ö");
	word =  replaceAll(word, "&szlig;", "ß");

	word =  replaceAll(word, "&otilde;", "ő");
	word =  replaceAll(word, "&Otilde;", "Ő");
	word =  replaceAll(word, "&ucirc;", "ű");
	word =  replaceAll(word, "&Ucirc;", "Ű");
	word =  replaceAll(word, "&oacute;", "ó");
	word =  replaceAll(word, "&Oacute;", "Ó");
	word =  replaceAll(word, "&uacute;", "ú");
	word =  replaceAll(word, "&Uacute;", "Ú");
	word =  replaceAll(word, "&iacute;", "í");
	word =  replaceAll(word, "&Iacute;", "Í");
	word =  replaceAll(word, "&eacute;", "é");
	word =  replaceAll(word, "&Eacute;", "É");
	word =  replaceAll(word, "&aacute;", "á");
	word =  replaceAll(word, "&Aacute;", "Á");
	
	return word;
}


function transformResult(result)
{
	var resultString = "";
    var replaceString = word;
	if(result != null && result.length > 0)
	{
        var rows = result.split("\n");
        for(var i=0; i<rows.length; i++)
        {
            var row = rows[i].split(fieldSeparator);    // " :: "
            var first = 0;
            var second = 1;
		
            if(	row[1] && row[0] && (row[0].charAt(0) != '#'))
            {
                resultString += "<div class='spacer'></div><div class='spacerLine'></div><div class='spacer'></div>";
                resultString += "<div class='firstLine'>";
                resultString = resultString + row[first];
                resultString += "</div>";
                resultString += "<div class='secondLine'>";
                resultString = resultString + row[second];
                resultString += "</div>";
            }
            
            // resultString = resultString.replace(word, "<u>"+word+"</u>");
            resultString = replaceAll(resultString, word, "<u>"+word+"</u>"); 
        }
        resultString += "<div class='spacerBig'></div>";
    }
	
    return resultString;
}


//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    
}


function errorHandler(currentStringOnStdout)
{    
    // displayResult(currentStringOnStdout);
}

function jsonLoaded(jsonRequest, langPairValue) {

    if(jsonRequest.readyState == 4 && jsonRequest.status == 200) {
        var json = eval ( "(" + jsonRequest.responseText + ")" );
        var translatedText = json.responseData.translatedText;
        // var sourceLanguage = json.responseData.detectedSourceLanguage;
        var responseDetails = json.responseDetails;
        var responseData = json.responseData;
        
        if(responseData != null) {
            if( strncasecmp (translatedText, originalWord, originalWord.length) != 0 ) {
                if(langPairValue==langPair_1) {
                    var remoteResult = transformResult(originalWord + " :: " + translatedText);
                } else {
                    var remoteResult = transformResult(translatedText + " :: " + originalWord);            
                }

                document.getElementById('content').innerHTML = remoteResult;

                googleFound = true;
                //googleAddButton = document.getElementById("addWordButton");
                //googleAddButton.object.setEnabled(true);
            } else {
                // retry with new language pair
                //document.getElementById('content').innerHTML = "langPair="+langPairValue;

                if(langPairValue==langPair_1) {
                    //document.getElementById('content').innerHTML = "2";
                    remoteTranslate(langPair_2);
                } else {
                    document.getElementById('content').innerHTML = "<center>:(</center>";
                    googleFound = false;
                    //googleAddButton = document.getElementById("addWordButton");
                    //googleAddButton.object.setEnabled(false);
                }
            }
        } else {
            document.getElementById('content').innerHTML = responseDetails;
        }
	}
	else {
		// alert("Error fetching data: HTTP status " + jsonRequest.status);
        document.getElementById('content').innerHTML = "Unable to access Google Translate engine... ("+jsonRequest.status+")";
	}
    
    currentlyBeingTranslated = null;
}


function jsonLoadedLanguage(jsonRequest, langPairValue) {

    if(jsonRequest.readyState == 4 && jsonRequest.status == 200) {
        var json = eval ( "(" + jsonRequest.responseText + ")" );
        var language = json.responseData.language;
        var isReliable = json.responseData.isReliable;
        var responseDetails = json.responseDetails;
        var responseData = json.responseData;
        
        if(responseData != null) {
            // TODO
        } else {
            document.getElementById('content').innerHTML = responseDetails;
        }
	}
	else {
        document.getElementById('content').innerHTML = "Unable to access Google Translate engine... ("+jsonRequest.status+")";
	}
    
    currentlyBeingTranslated = null;
}



function doneTranslation() {
    
    var localResult = transformResult(translateCommand.outputString);
    
    if(localResult.length>2) {
        // show local search result
        document.getElementById('content').innerHTML = localResult;
    } else {
        // missing local answer, just query from google...
        remoteTranslate(langPair_1);
    }
    
    translateCommand = null;
    currentlyBeingTranslated = null;
}

function remoteTranslate(langPairValue) {

    if(translateCommand != null) {
        translateCommand.cancel();
    }

    if( currentlyBeingTranslated == null) {

        var queryText = encodeURIComponent(originalWord);

        /*
        // detect language
        if(queryText.length>2) {
            queryURL = googleUrlDetectLanguage + "&" + googleQueryText + queryText;

            // load handler
            var onloadHandler = function() { jsonLoadedLanguage(jsonRequest, langPairValue); };

            // XMLHttpRequest setup code
            var jsonRequest = new XMLHttpRequest();
            currentlyBeingTranslated = jsonRequest;
            if(jsonRequest==null) {
                document.getElementById('content').innerHTML = "Unable to create network connection to Google Translate engine...";
                return(false);
            } else {
                jsonRequest.onload = onloadHandler;
                jsonRequest.open("GET", queryURL);
                jsonRequest.setRequestHeader("Cache-Control", "no-cache");
                jsonRequest.send(null);
            }            
        }
        */
        
        // translate text
        if(queryText.length>2) {
            queryURL = googleUrl + "&" + googleLangpair + langPairValue + "&" + googleQueryText + queryText;
        
            // load handler
            var onloadHandler = function() { jsonLoaded(jsonRequest, langPairValue); };

            // XMLHttpRequest setup code
            var jsonRequest = new XMLHttpRequest();
            currentlyBeingTranslated = jsonRequest;
            if(jsonRequest==null) {
                document.getElementById('content').innerHTML = "Unable to create network connection to Google Translate engine...";
                return(false);
            } else {
                jsonRequest.onload = onloadHandler;
                // jsonRequest.onreadystatechange = onloadHandler; 
                jsonRequest.open("GET", queryURL);
                // jsonRequest.setRequestHeader("Content-Type" , "text/javascript");
                jsonRequest.setRequestHeader("Cache-Control", "no-cache");
                //jsonRequest.setRequestHeader("Pragma", "no-cache");        
                return(jsonRequest.send(null));
            }
        }
    } else {
        // document.getElementById('content').innerText = "???:"+currentlyBeingTranslated+","+translateCommand;
    }
}


function displayResult(result)
{
    originalWord = document.getElementById('searchfield').value;
    if(originalWord.length>1) {
        word = HTMLencode(originalWord);

        if(translateCommand != null) {
            translateCommand.cancel();
        }

        commandString = createGrepCommand(word, false);
        googleFound = false;
        //googleAddButton = document.getElementById("addWordButton");
        //googleAddButton.object.setEnabled(false);
        
        translateCommand = widget.system(commandString, doneTranslation);
    } else {
        document.getElementById('content').innerHTML = "<center>...</center>";
    }
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    
    if(googleFound) {
        // var clickedText = event.toElement.innerText;
        var sourceElement = document.getElementById('content');
        var clickedText = sourceElement.innerText;   // .innerHTML;
        // var firstText = clickedText.split("\n")[0];
        // var secondText = clickedText.split("\n")[1];
        var firstText = sourceElement.children[3].innerText;
        var secondText = sourceElement.children[4].innerText;
        
        document.getElementById('firstTextToAdd').value = firstText;
        document.getElementById('secondTextToAdd').value = secondText;
        
        // var c = addMyWordCommand+" \""+firstText+fieldSeparator+secondText+"\"";
        // widget.system(c, doneAddWord);
        // document.getElementById('content').innerHTML = c;
    }

}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

// Replaces all instances of the given substring.
function replaceAll(text, strA, strB)
{
    return text.replace( new RegExp(strA,"gi"), strB );    
}

// URLencode
function urlencode(str) {
    return escape(str).replace(/\+/g,'%2B').replace(/%20/g, '+').replace(/\*/g, '%2A').replace(/\//g, '%2F').replace(/@/g, '%40');
}

function strncasecmp (argStr1, argStr2, len) {
    // http://kevin.vanzonneveld.net
    // +   original by: Saulo Vallory
    // +      input by: Nate
    // +   bugfixed by: Onno Marsman
    // %          note: Returns < 0 if str1 is less than str2 ; > 0 if str1 is greater than str2 , and 0 if they are equal.
    // *     example 1: strncasecmp('Price 12.9', 'Price 12.15', 2);
    // *     returns 1: 0
    // *     example 2: strncasecmp('Price 12.09', 'Price 12.15', 10);
    // *     returns 2: -1
    // *     example 3: strncasecmp('Price 12.90', 'Price 12.15', 30);
    // *     returns 3: 8
    // *     example 4: strncasecmp('Version 12.9', 'Version 12.15', 20);
    // *     returns 4: 8
    // *     example 5: strncasecmp('Version 12.15', 'Version 12.9', 20);
    // *     returns 5: -8
 
    var diff, i = 0;
    var str1 = (argStr1+'').toLowerCase().substr(0,len);
    var str2 = (argStr2+'').toLowerCase().substr(0,len);
 
    if(str1.length !== str2.length) {
        if(str1.length < str2.length) {
            len = str1.length;
            if(str2.substr(0, str1.length) == str1) {
                return str1.length - str2.length; // return the difference of chars
            }
        } else {
            len = str2.length;
            // str1 is longer than str2
            if(str1.substr(0, str2.length) == str2) {
                return str1.length - str2.length; // return the difference of chars
            }
        }
    } else {
        // Avoids trying to get a char that does not exist
        len = str1.length;
    }
 
    for(diff = 0, i=0; i < len; i++) {
        diff = str1.charCodeAt(i) - str2.charCodeAt(i);
        if(diff !== 0) {
            return diff;
        }
    }
 
    return 0;
}
